(require "win32")
(require "win32com")
(in-package "WIN32-COM")


;;;;
;;;; Application Server
;;;;

(when (find "-RegServer" *command-line* :test #'string=)
  (let ((command (format nil "~awxls32.exe Autoload\\win32com\\server"
                         *default-path*))
        (clsid "{FB4C2CC0-60EF-11D3-8E98-444553540000}")
        (friendly-name "XlispStat COM Server")
        (progid "XlispStat.application.1")
        (vi-progid "XlispStat.application"))
    (register-com-server command clsid friendly-name progid vi-progid))
  (exit))

(when (find "-UnregServer" *command-line* :test #'string=)
  (let ((clsid "{FB4C2CC0-60EF-11D3-8E98-444553540000}")
        (progid "XlispStat.application.1")
        (vi-progid "XlispStat.application"))
    (unregister-com-server clsid progid vi-progid))
  (exit))


;;;
;;; Server Implementation
;;;

(defparameter *xlispstat-auto-server* (send auto-server :new))

(defmeth *xlispstat-auto-server* :load (file)
  (load file))
(send *xlispstat-auto-server* :add-auto-method :load :load)

(defmeth *xlispstat-auto-server* :eval (expr)
  (eval (read-from-string expr)))
(send *xlispstat-auto-server* :add-auto-method :eval :eval)
(send *xlispstat-auto-server* :add-auto-method :evalnovalue :eval nil)

(defmeth *xlispstat-auto-server* :eval-all-values (expr)
  (coerce (multiple-value-list (eval (read-from-string expr))) 'vector))
(send *xlispstat-auto-server* :add-auto-method :evalallvalues :eval-all-values)

(defmeth *xlispstat-auto-server* :call (fun &rest args)
  (apply (read-from-string fun) args))
(send *xlispstat-auto-server* :add-auto-method :call :call)
(send *xlispstat-auto-server* :add-auto-method :callnovalue :call nil)

(defmeth *xlispstat-auto-server* :call-all-values (fun &rest args)
  (coerce (multiple-value-list (apply (read-from-string fun) args)) 'vector))
(send *xlispstat-auto-server* :add-auto-method :callallvalues :call-all-values)

(defmeth *xlispstat-auto-server* :create (name &rest args)
  (apply #'send (symbol-value (read-from-string name)) :new args))
(send *xlispstat-auto-server* :add-auto-method :create :create)

(defmeth *xlispstat-auto-server* :visible (&optional (vis nil set))
  (if set (msw-main-frame-visible vis) (msw-main-frame-visible)))
(send *xlispstat-auto-server* :add-auto-property :visible :visible :visible)

(defparameter *xlispstat-class-factory*
  (send class-factory :new *xlispstat-auto-server* :singleton t))

(send *xlispstat-class-factory* :register "XlispStat.application")
